//
// Created by trokay on 13.06.23.
//

#ifndef MC_0203_UART_H
#define MC_0203_UART_H

#define BUFFER_SIZE 256
#define MESSAGE_SIZE 256

#define UART_NAME "/dev/ttyAMA0"
#define BAUDRATE 115200

struct uart_t {
    int fd;
    char buffer[BUFFER_SIZE];
    char message[MESSAGE_SIZE];
    int head;
    int tail;
    int size;
    uint8_t flag;

    int (*invoke)(struct uart_t *);
};

int close_uart(struct uart_t *uart);

int init_uart(struct uart_t *uart, const char *name, int baudrate);

int read_uart_circle(struct uart_t *uart);

#endif //MC_0203_UART_H
